//	WDMhCoTv(MSR̓ǂݍ)
//	Windows XP Vista 7 32bit OS

#ifdef __cplusplus
	extern "C" {
#endif

#include <wdm.h>

#define IOCTL_RDMSR_CODE 0x800

//	Gg[|Cg
DRIVER_INITIALIZE DriverEntry;

//	Create
__drv_dispatchType(IRP_MJ_CREATE) DRIVER_DISPATCH CreateFunction;
NTSTATUS CreateFunction(IN PDEVICE_OBJECT DeviceObject,IN PIRP Irp);

//	Close
__drv_dispatchType(IRP_MJ_CLOSE) DRIVER_DISPATCH CloseFunction;
NTSTATUS CloseFunction(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);

//	DeviceControl
__drv_dispatchType(IRP_MJ_DEVICE_CONTROL) DRIVER_DISPATCH DeviceControlFunction;
NTSTATUS DeviceControlFunction(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);

//	AddDevice
NTSTATUS AddDeviceFunction(IN PDEVICE_OBJECT DriverObject, IN PDEVICE_OBJECT DeviceObjcet);

//	UnloadDriver
DRIVER_UNLOAD UnloadDriverFunction;

#ifdef ALLOC_PRAGMA
#pragma alloc_text( INIT, DriverEntry )
#pragma alloc_text( PAGE, CreateFunction)
#pragma alloc_text( PAGE, CloseFunction)
#pragma alloc_text( PAGE, DeviceControlFunction)
#pragma alloc_text( PAGE, AddDeviceFunction)
#pragma alloc_text( PAGE, UnloadDriverFunction)

#endif

#ifdef __cplusplus
	}
#endif

//	hCo[[hꂽƂɌĂяo֐
NTSTATUS DriverEntry(IN PDRIVER_OBJECT pDriverObject,IN PUNICODE_STRING pRegistryPath){
	UNICODE_STRING usDeviceName,usDosDeviceName;
	PAGED_CODE();
	RtlInitUnicodeString( &usDeviceName, L"\\Device\\msrtest" );
	RtlInitUnicodeString(&usDosDeviceName, L"\\DosDevices\\msrtest");

	PDEVICE_OBJECT pDeviceObject = NULL;
	NTSTATUS NtStatus=IoCreateDevice( pDriverObject, 0, &usDeviceName, FILE_DEVICE_SECURE_OPEN, 0, FALSE, &pDeviceObject);
	if( NtStatus != STATUS_SUCCESS){
		return NtStatus;
	}
	pDriverObject->MajorFunction[IRP_MJ_CREATE]=CreateFunction;	//	CreateFileĂяȍo^
	pDriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] = DeviceControlFunction;	//	DeviceControlĂяȍo^
	pDriverObject->MajorFunction[IRP_MJ_CLOSE]=CloseFunction;	//	CloseFileĂяȍo^
	
	pDriverObject->DriverUnload = UnloadDriverFunction;	//	hCoA[h鎞̏o^

	NTSTATUS status = IoCreateSymbolicLink(&usDosDeviceName, &usDeviceName);

	return STATUS_SUCCESS;
}

//	Create
NTSTATUS CreateFunction(IN PDEVICE_OBJECT DeviceObject,IN PIRP Irp){
	PAGED_CODE();
	return STATUS_SUCCESS;
}

//	Close
NTSTATUS CloseFunction(IN PDEVICE_OBJECT DeviceObject,IN PIRP Irp){
	PAGED_CODE();
	return STATUS_SUCCESS;
}

//	DeviceControl   g,on/off
NTSTATUS DeviceControlFunction(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp){
	PAGED_CODE();
	int dwDataRead = 0, dwDataWritten = 0;
	NTSTATUS NtStatus = STATUS_NOT_SUPPORTED;
	PIO_STACK_LOCATION pIoStackIrp = IoGetCurrentIrpStackLocation(Irp);
	if (pIoStackIrp){
		// ANZXID𒲂ׂ
		if (pIoStackIrp->Parameters.DeviceIoControl.IoControlCode == IOCTL_RDMSR_CODE){
			// obt@|C^擾
			PCHAR pInputBuffer = (PCHAR)Irp->AssociatedIrp.SystemBuffer;
			PCHAR pOutputBuffer = (PCHAR)Irp->AssociatedIrp.SystemBuffer;
			// obt@TCY擾
			int InSize = pIoStackIrp->Parameters.DeviceIoControl.InputBufferLength;
			int OutSize = pIoStackIrp->Parameters.DeviceIoControl.OutputBufferLength;
			DWORD32 ads = *(DWORD32*)pInputBuffer;
			DWORD32* d32 = (DWORD32*)pOutputBuffer;
			DWORD32 l, h;
			__try{
				__asm{
					mov	ecx, ads
					rdmsr
					mov	l, eax
					mov	h, edx
				}
				d32[0] = l;
				d32[1] = h;
				Irp->IoStatus.Information = 8;
				NtStatus = STATUS_SUCCESS;
			}
			__except (EXCEPTION_EXECUTE_HANDLER){
				Irp->IoStatus.Information = 0;
				NtStatus = STATUS_NOT_SUPPORTED;
			}
		}
	}
	Irp->IoStatus.Status = NtStatus;
	IoCompleteRequest(Irp, IO_NO_INCREMENT);
	return STATUS_SUCCESS;
}

//	AddDevice
NTSTATUS AddDeviceFunction(IN PDEVICE_OBJECT DriverObject, IN PDEVICE_OBJECT DeviceObjcet){
	PAGED_CODE();
	return STATUS_SUCCESS;
}

//	UnloadDriver
VOID UnloadDriverFunction(IN PDRIVER_OBJECT DriverObject){
	PAGED_CODE();
	IoDeleteDevice(DriverObject->DeviceObject);
}
